/*
	tray2file_backend.c

	original code: SASANO Takayoshi
	--- public domain, no warranty.
*/

#include "common.h"

/* $BJ8>O3+;O%;%0%a%s%H(B */
LOCAL	const UH	TextSeg[] = {
	XeH(TC_SPEC | TS_TEXT),		// $BJ8>O%;%0%a%s%H(B
	XeH(0x0018),			// $B%G!<%?K\BN$N%P%$%HD9(B
	XeH(0), XeH(0), XeH(0), XeH(0),	// $BI=<(NN0h(B
	XeH(0), XeH(0), XeH(0), XeH(0),	// $BIA2hNN0h(B
	XeH(0x0000),			// $B?eJ?%f%K%C%H(B
	XeH(0x0000),			// $B?bD>%f%K%C%H(B
	XeH(0x0021),			// $B%G%U%)!<%k%H8@8l!JF|K\8l!K(B
	XeH(0x0000),			// $BGX7J%Q%?!<%s(BID$B!JF)L@!K(B
};

/* $BJ8>O=*N;%;%0%a%s%H(B */
LOCAL	const UH	TextEndSeg[] = {
	XeH(TC_SPEC | TS_TEXTEND),	// $BJ8>O=*N;%;%0%a%s%H(B
	XeH(0x0000),			// $B%G!<%?K\BN$N%P%$%HD9(B
};

/* $B?^7A=*N;%;%0%a%s%H(B */
LOCAL	const UH	FigEndSeg[] = {
	XeH(TC_SPEC | TS_FIGEND),	// $B?^7A=*N;%;%0%a%s%H(B
	XeH(0x0000),			// $B%G!<%?K\BN$N%P%$%HD9(B
};

#ifdef	DEBUG
/* $B%G%P%C%0;Y1g(B */
typedef	struct {
	UB	*str;
	W	id;
} SegName;

LOCAL	const SegName	NameTbl[] = {
	{"TR_VOBJ",	0x01},
	{"TR_TEXT",	0x02},
	{"TR_FIG",	0x03},
	{"TS_INFO",	0xE0},
	{"TS_TEXT",	0xE1},
	{"TS_TEXTEND",	0xE2},
	{"TS_FIG",	0xE3},
	{"TS_FIGEND",	0xE4},
	{"TS_IMAGE",	0xE5},
	{"TS_VOBJ",	0xE6},
	{"TS_DFUSEN",	0xE7},
	{"TS_FFUSEN",	0xE8},
	{"TS_SFUSEN",	0xE9},
	{"TS_TPAGE",	0xA0},
	{"TS_TRULER",	0xA1},
	{"TS_TFONT",	0xA2},
	{"TS_TCHAR",	0xA3},
	{"TS_TATTR",	0xA4},
	{"TS_TSTYLE",	0xA5},
	{"TS_TVAR",	0xAD},
	{"TS_TMEMO",	0xAE},
	{"TS_TAPPL",	0xAF},
	{"TS_FPRIM",	0xB0},
	{"TS_FDEF",	0xB1},
	{"TS_FGRP",	0xB2},
	{"TS_FMAC",	0xB3},
	{"TS_FATTR",	0xB4},
	{"TS_FPAGE",	0xB5},
	{"TS_FMEMO",	0xBE},
	{"TS_FAPPL",	0xBF},
	{"unknown",	~0},
};

LOCAL	UB	*find_segname(UB id)
{
	W	i;

	for (i = 0; i < sizeof(NameTbl) / sizeof(SegName) - 1; i++) {
		if (id == NameTbl[i].id) break;
	}

	return NameTbl[i].str;
}
#endif	

/* $BO"B3$7$?%l%3!<%I?t$r?t$($k(B */
LOCAL	W	count_contrec(TRAYREC *tray, W rec, W *len)
{
	W	c;

	c = *len = 0;

	/* $B%l%3!<%I$NO"B3@-$O!"@\B3%U%i%0$NM-L5$N$_$GH=Dj$9$k(B */
	do {
		c++;
		*len += tray->len;

	} while (--rec > 0 && ((tray++)->id & TR_CONT));

	return c;
}

/* ID$B$H%;%0%a%s%H<oJL$H$NBP1~IU$1(B */
LOCAL	W	check_recid(W id)
{
	W	result;

	result = 0;

	switch (id) {

	/* $B2>?H7O(B */
	case	TR_VOBJ:	// 0x01: $B2>?H%l%3!<%I(B
	case	TS_VOBJ:	// 0xE6: $B2>?H%;%0%a%s%H(B
		result = OPTION_VOBJ;
		break;

	/* $BJ8>O7O(B */
	case	TR_TEXT:	// 0x02: $BJ8>O%l%3!<%I(B
	case	TS_TEXT:	// 0xE1: $BJ8>O3+;O%;%0%a%s%H(B
	case	TS_TEXTEND:	// 0xE2: $BJ8>O=*N;%;%0%a%s%H(B
				// $B"((BTS_TPAGE(0xA0)$B!A(BTS_TAPPL(0xAF)$B$O>JN,(B
		result = OPTION_TEXT;
		break;

	/* $B?^7A7O(B */
	case	TR_FIG:		// 0x03: $B?^7A%l%3!<%I(B
	case	TS_FIG:		// 0xE3: $B?^7A3+;O%;%0%a%s%H(B
	case	TS_FIGEND:	// 0xE4: $B?^7A=*N;%;%0%a%s%H(B
	case	TS_IMAGE:	// 0xE5: $B2hA|%;%0%a%s%H(B
				// $B"((BTS_FPRIM(0xB0)$B!A(BTS_FAPPL(0xBF)$B$O>JN,(B
		result = OPTION_FIG;
		break;

	/* $BIUd57O(B */
	case	TS_DFUSEN:	// 0xE7: $B;XDjIUd5%;%0%a%s%H(B
	case	TS_FFUSEN:	// 0xE8: $B5!G=IUd5%;%0%a%s%H(B
	case	TS_SFUSEN:	// 0xE9: $B@_DjIUd5%;%0%a%s%H(B
		result = OPTION_FUSEN;
		break;

	/* $B$=$NB>(B */
	default:
		DP(("check_rec: unknown id %x\n", id));
		/* fall-through */

	case	TS_INFO:	// 0xE0: $B4IM}>pJs%;%0%a%s%H(B
		break;
	}

	return result;
}

/* $B%;%0%a%s%H%X%C%@$N=q$-=P$7(B */
LOCAL	W	write_seghdr(W fd, W id, W len)
{
	W	err;
	TADSEG	s;
	LTADSEG	ls;

	id |= 0xff00;

	if (len < 0xffff) {
		/* $BDL>o%;%0%a%s%H(B */
		s.id = XeH(id);
		s.len = XeH(len);

		err = wri_rec(fd, -1, (UB *)&s, sizeof(s), NULL, NULL, 0);
	} else {
		/* $B%i!<%8%;%0%a%s%H(B */
		ls.id = XeH(id);
		ls.len = XeH(0xffff);
		ls.llen = XeW(len);

		err = wri_rec(fd, -1, (UB *)&ls, sizeof(ls), NULL, NULL, 0);
	}
	if (err < ER_OK) {
		DP(("create_seghdr: wri_rec %d\n", err));
	}

	return err;
}

/* $B2>?H%;%0%a%s%H$N=q$-=P$7(B */
LOCAL	W	write_vobjseg(W fd, VP p, W len)
{
	W	err;
	TR_VOBJREC	*v = p;

	/* $B2>?H%;%0%a%s%H$N%5%$%:$rF@$k(B */
	len -= sizeof(VLINK);

	/* $B%;%0%a%s%H%X%C%@(B */
	err = write_seghdr(fd, TS_VOBJ, len);
	if (err < ER_OK) {
		DP(("write_vobjseg: write_seghdr %d\n", err));
		goto fin0;
	}

	/* $B%;%0%a%s%HK\BN(B */
	err = wri_rec(fd, -1, (UB *)&v->vseg, len, NULL, NULL, 0);
	if (err < ER_OK) {
		DP(("write_vobjseg: wri_rec %d\n", err));
		goto fin0;
	}

 fin0:
	return err;
}

/* $B2>?HL>$N=q$-=P$7(B */
LOCAL	W	write_vobjname(W fd, VP p, W option)
{
	W	err;
	TR_VOBJREC	*v = p;
	TC	vname[L_FNM + 1], nl = XeH(TC_NL);

	memset(vname, sizeof(vname), 0);

	/* $B2>?HL>$N<hF@(B */
	err = fil_sts((LINK *)&v->vlnk, vname, NULL, NULL);
	if (err < ER_OK) {
		DP(("write_vobjname: fil_sts %d\n", err));
		goto fin0;
	}

	/* $B2>?HL>$N=q$-=P$7(B */
	err = wri_rec(fd, -1, (UB *)vname,
		      tc_strlen(vname) * sizeof(TC), NULL, NULL, 0);
	if (err < ER_OK) {
		DP(("backend_main: wri_rec %d\n", err));
		goto fin0;
	}

	/* $B2~CJMn$NDI2C(B */
	if (option & OPTION_ADDNL) { 
		err = wri_rec(fd, -1, (UB *)&nl, sizeof(nl), NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("backend_main: wri_rec %d\n", err));
			goto fin0;
		}
	}
 fin0:
	return err;
}

/* $B%H%l!<%l%3!<%I$r%U%!%$%k$KJ]B8(B */
LOCAL	W	save_trayrec(W fd, W option, TRAYREC *t, W id, W len, W rec)
{
	W	err;

	DP(("save_trayrec: id %08x len %08x rec %08x\n", id, len, rec));

	/* $B%;%0%a%s%H%X%C%@$r:n@.$9$k(B */
	switch (id) {
	case	TR_VOBJ:
		if (t->len >= (sizeof(VLINK) + SIZE_VOBJSEG(0))) {
			err = (option & OPTION_VOBJNAME) ?
				write_vobjname(fd, t->dt, option) :
				write_vobjseg(fd, t->dt, t->len);
			if (err < ER_OK) {
				DP(("save_trayrec: write_vobjseg %d\n", err));
			}
		} else {
			/* $BIT@5$J2>?H%l%3!<%I$O%9%-%C%W$9$k(B */
			err = ER_OK;
			DP(("save_trayrec: t->len %d\n", t->len));
		}
		goto fin0;	// $B$3$l0J9_$N=hM}$OITMW(B

	case	TR_TEXT:
	case	TR_FIG:
		err = ER_OK;	// $B2?$b$9$kI,MW$OL5$$(B
		break;

	default:
		err = write_seghdr(fd, id, len);
		if (err < ER_OK) {
			DP(("save_trayrec: write_seghdr %d\n", err));
			goto fin0;
		}
		break;
	}

	/* $B%H%l!<%l%3!<%I$N=q$-=P$7(B */
	for (err = ER_OK; rec > 0; rec--, t++) {
		err = wri_rec(fd, -1, t->dt, t->len, NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("save_trayrec: wri_rec %d\n", err));
			goto fin0;
		}
	}

 fin0:
	return err;
}

/* $B=*N;%;%0%a%s%H$NDI2C(B */
LOCAL	W	append_endseg(W fd, const UH *seg, W segsize, W segs)
{
	W	err, i;

	err = ER_OK;

	for (i = 0; i < segs; i++) {
		err = wri_rec(fd, -1, (UB *)seg, segsize, NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("append_endseg: wri_rec %d\n", err));
			goto fin0;
		}
	}

 fin0:
	return err;
}

/* $B%j%s%/%l%3!<%I$NDI2C(B */
LOCAL	W	append_vlink(W fd, TRAYREC *t, W rec)
{
	W	err, i, c, len;
	TR_VOBJREC	*v;

	err = ER_OK;

	for (i = 0; i < rec; i += c, t += c) {

		/* $BO"B3$7$?%l%3!<%I?t$rD4$Y$k(B */
		c = count_contrec(t, rec - i, &len);

		/* $B@5$7$$2>?H%l%3!<%I0J30$O!"%9%-%C%W$9$k(B */
		if (t->id != TR_VOBJ ||
		    t->len < (sizeof(VLINK) + SIZE_VOBJSEG(0))) continue;

		v = (TR_VOBJREC *)t->dt;
		err = apd_rec(fd, (UB *)&v->vlnk, sizeof(VLINK),
			      NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("append_vlink: apd_rec %d\n", err));
			goto fin0;
		}	
	}

 fin0:
	return err;
}	

/* $B%H%l!<FbMF$N=q$-=P$7(B */
LOCAL	W	backend_main(W fd, W option, TC *comment, TRAYREC *tray, W rec)
{
	W	err, i, c, id, len, stxt, sfig;
	TRAYREC	*t;

#ifdef	DEBUG
	/* $B%G%P%C%0MQ(B */
	for (i = 0; i < rec; i++) {
		DP(("backend_main: id %08x len %08x dt %08x <%s>\n",
		    tray[i].id, tray[i].len, tray[i].dt,
		    find_segname(tray[i].id)));
	}
#endif

	stxt = sfig = 0;

	/* $B%3%a%s%H$N=q$-=P$7(B */
	if (comment != NULL) {
		UH	nl = XeH(TC_NL);

		/* $BJ8>O3+;O%;%0%a%s%H(B */
		err = wri_rec(fd, -1, (UB *)TextSeg,
			      sizeof(TextSeg), NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("backend_main: wri_rec %d\n", err));
			goto fin0;
		}

		/* $B%3%a%s%HK\J8(B */
		err = wri_rec(fd, -1, (UB *)comment, 
			      tc_strlen(comment) * sizeof(TC), NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("backend_main: wri_rec %d\n", err));
			goto fin0;
		}

		/* $B2~CJMn(B */
		err = wri_rec(fd, -1, (UB *)&nl, sizeof(nl), NULL, NULL, 0);
		if (err < ER_OK) {
			DP(("backend_main: wri_rec %d\n", err));
			goto fin0;
		}

		/* $BJ8>O=*N;%;%0%a%s%H(B */
		err = append_endseg(fd, TextEndSeg, sizeof(TextEndSeg), 1);
		if (err < ER_OK) {
			DP(("backend_main: add_endseg %d\n", err));
			goto fin0;
		}
	}

	/* $B%H%l!<FbMF$N=q$-=P$7(B */
	for (i = 0, t = tray; i < rec; i += c, t += c) {

		/* $BO"B3$7$?%l%3!<%I?t$rD4$Y$k(B */
		c = count_contrec(t, rec - i, &len);

		/* $BL\E*$H$7$J$$%l%3!<%I$G$"$l$P!"%9%-%C%W$9$k(B */
		id = t->id & 0xff;
		if (!(check_recid(id) & option)) continue;

		/* $B=P8=$7$?3+;O!?=*N;%;%0%a%s%H$N8D?t$r?t$($k(B */
		switch (id) {
		case	TS_TEXT:	stxt++;		break;
		case	TS_TEXTEND:	stxt--;		break;
		case	TS_FIG:		sfig++;		break;
		case	TS_FIGEND:	sfig--;		break;
		default:				break;
		}

		/* $B%l%3!<%I?tJ,$@$1=q$-=P$9(B */
		err = save_trayrec(fd, option, t, id, len, c);
		if (err < ER_OK) {
			DP(("backend_main: save_trayrec %d\n", err));
			goto fin0;
		}
	}

	/* $B=*N;%;%0%a%s%H$,ITB-$7$?>l9g$O!"$=$l$J$j$KJd$&(B */
	DP(("backend_main: stxt %d sfig %d\n", stxt, sfig));
	err = append_endseg(fd, FigEndSeg, sizeof(FigEndSeg), sfig);
	if (err < ER_OK) {
		DP(("backend_main: add_endseg %d\n", err));
		goto fin0;
	}
	err = append_endseg(fd, TextEndSeg, sizeof(TextEndSeg), stxt);
	if (err < ER_OK) {
		DP(("backend_main: add_endseg %d\n", err));
		goto fin0;
	}

	/* $B%j%s%/%l%3!<%I$NDI2C(B */
	if ((option & (OPTION_VOBJ | OPTION_VOBJNAME)) == OPTION_VOBJ) {
		err = append_vlink(fd, tray, rec);
		if (err < ER_OK) {
			DP(("backend_main: append_vlink %d\n", err));
			goto fin0;
		}
	}

	err = ER_OK;

 fin0:
	return err;
}

/* backend entry */
EXPORT	W	tray2file_backend(W fd, W option, TC *comment)
{
	W	err, rec, size, asize;
	TRAYREC	*tray;

	/* $B%l%3!<%IA4BN$N%5%$%:!&%l%3!<%I?t$N<hF@(B */
	err = tpop_dat(NULL, 0, &size, -1, NULL);
	if (err < ER_OK) {
		DP(("tray2file_backend: tpop_dat %d\n", err));
		goto fin0;
	}
	rec = err;

	/* $B%l%3!<%I$,B8:_$7$J$$>l9g$O$3$3$G=*N;(B */
	if (!size) {
		DP(("tray2file_backend: no tray data\n"));
		err = ER_NOEXS;
		goto fin0;
	}

	/* $B%a%b%j3NJ](B */
	tray = malloc(size);
	if (tray == NULL) {
		DP(("tray2file_backend: malloc NULL\n"));
		err = ER_NOMEM;
		goto fin0;
	}

	/* $B%l%3!<%IA4BN$NFI$_=P$7(B */
	err = tpop_dat(tray, size, &asize, -1, NULL);
	if (err < ER_OK) {
		DP(("tray2file_backend: tpop_dat %d\n", err));
		goto fin1;
	}

	/* $B%P%C%/%(%s%IK\BN$r<B9T(B */
	err = backend_main(fd, option, comment, tray, rec);
	if (err < ER_OK) {
		DP(("tray2file_backend: backend_main %d\n", err));
		goto fin1;
	}

 fin1:
	free(tray);
 fin0:
	return err;
}
